

#include <PID_v2.h> // PID Regler aus einer Bibliothek

#define PIN_INPUT 0  // Festlegung des Eingangs für die Regelgröße x
#define PIN_OUTPUT 9 // Festlegung des Ausgangs für die Stellgröße y

// Festlegung der Reglerparameter
double Kp = 0.1, Ki = 0.1 , Kd = 0.;
PID_v2 myPID(Kp, Ki, Kd, PID::Direct);

void setup() {
  Serial.begin(9600);   // Öffnung der seriellen Schnittstelle
  myPID.Start(analogRead(PIN_INPUT),  // Start des Reglers : Einlesen der Regelgröße x
              0,                      // Anfangswert für die Stellgröße y
              205);                   // Führungsgröße w = 205 entspricht 1000 U/min (siehe Projektbeschreibung)
}

void loop() {
  const double input = analogRead(PIN_INPUT); // Eingabe der Regelgröße x in den Regelalgorithmus
  const double output = myPID.Run(input);     // Berechnung der Stellgröße
  analogWrite(PIN_OUTPUT, output);            // Ausgabe der Stellgröße y auf Kanal 9 (PWM Ausgang)
  Serial.print("Regelgröße x:");// Angabe der Regelgrösse auf dem Monitor
  Serial.println(input); // Regelgröße x
  Serial.print ("Führungsgröße w:"); // Angabe der Führungsgröße auf dem Monitor
  Serial.println(205);  // Führungsgröße w
  
}
